extends Spatial

var previously_had_intersection = false
var ray_start
var ray_normal

onready var camera = $Camera

func _input(event):
  if event is InputEventMouseMotion:
    ray_start = camera.project_ray_origin(event.position)
    ray_normal = camera.project_ray_normal(event.position)

func _physics_process(delta):
  if ray_start == null:
    return

  var state = get_world().direct_space_state
  var ray_end = ray_start + ray_normal * 1000
  var intersection = state.intersect_ray(ray_start, ray_end, [], 0x7fffffff, false, true)

  var had_intersection = not intersection.empty()
  if had_intersection != previously_had_intersection:
    print(had_intersection)
  previously_had_intersection = had_intersection
